'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _EthSyncCursor = require('./EthSyncCursor');

var _EthSyncCursor2 = _interopRequireDefault(_EthSyncCursor);

var _yup = require('yup');

var yup = _interopRequireWildcard(_yup);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var schema = yup.object().shape({
  address: yup.string().required("Sync missing contract address"),
  abi: yup.array().min(1).required("Sync missing ABI array"),
  snapshotProvider: yup.object() //not required
});

var EthSync = function () {
  function EthSync(props) {
    var _this = this;

    _classCallCheck(this, EthSync);

    schema.validateSync(props);

    this.web3Factory = props.web3Factory;
    if (typeof this.web3Factory !== 'function') {
      throw new Error("Sync has invalid web3Factory property. Must be a function");
    }
    this.address = props.address;
    this.abi = props.abi;
    this.snapshotProvider = props.snapshotProvider;

    ['start'].forEach(function (fn) {
      return _this[fn] = _this[fn].bind(_this);
    });
  }

  _createClass(EthSync, [{
    key: 'start',
    value: function start(_ref, callback, badCallback) {
      var eventName = _ref.eventName,
          options = _ref.options,
          fromBlock = _ref.fromBlock,
          toBlock = _ref.toBlock;


      var web3 = this.web3Factory();
      var con = new web3.eth.Contract(this.abi, this.address, { address: this.address });
      var c = new _EthSyncCursor2.default({
        fromBlock: fromBlock,
        toBlock: toBlock,
        eventName: this.eventName,
        web3: web3,
        contract: con,
        options: this.options,
        snapshotProvider: this.snapshotProvider
      });

      return c.init(callback, badCallback);
    }
  }]);

  return EthSync;
}();

exports.default = EthSync;
//# sourceMappingURL=EthSync.js.map