'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _stream = require('stream');

var _stream2 = _interopRequireDefault(_stream);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var byBlockAndHash = function byBlockAndHash(events) {
  var byBlock = {};
  events.forEach(function (e) {
    var byHash = byBlock[e.blockNumber] || {};
    var logEvents = byHash[e.transactionHash] || {};
    var set = logEvents[e.event] || [];
    set.push(e);
    logEvents[e.event] = set;
    byHash[e.transactionHash] = logEvents;
    byBlock[e.blockNumber] = byHash;
  });
  return byBlock;
};

var MockSnapper = function () {
  function MockSnapper(props) {
    var _this = this;

    _classCallCheck(this, MockSnapper);

    this.pass = _stream2.default.PassThrough();
    this.data = "";

    if (props.events) {
      var byBlock = byBlockAndHash(props.events);
      var blocks = _lodash2.default.keys(byBlock);
      blocks.sort(function (a, b) {
        return a - 0 - (b - 0);
      });

      //have to convert blocks into what cursor expects
      blocks = blocks.map(function (b) {
        var txns = [];
        var byHash = byBlock[b];
        _lodash2.default.keys(byHash).forEach(function (h) {
          var logEvents = byHash[h];
          //this is low level events organized by hash
          var txn = {
            transactionHash: h,
            transactionIndex: 0,
            blockNumber: b,
            logEvents: logEvents
          };
          txns.push(txn);
        });
        return {
          number: b,
          transactions: txns
        };
      });

      blocks.forEach(function (b) {
        _this.data += JSON.stringify(b) + "\n";
      });
    } else if (props.blocks) {
      props.blocks.forEach(function (b) {
        _this.data += JSON.stringify(b) + "\n";
      });
    }

    ['getLatest', 'pushEvents'].forEach(function (fn) {
      return _this[fn] = _this[fn].bind(_this);
    });
  }

  _createClass(MockSnapper, [{
    key: 'getLatest',
    value: function () {
      var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                return _context.abrupt('return', this.pass);

              case 1:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function getLatest() {
        return _ref.apply(this, arguments);
      }

      return getLatest;
    }()
  }, {
    key: 'pushEvents',
    value: function pushEvents() {
      var _this2 = this;

      return new Promise(function (done, err) {
        setTimeout(function () {
          _this2.pass.end(_this2.data);
          done();
        }, 500);
      });
    }
  }]);

  return MockSnapper;
}();

exports.default = MockSnapper;
//# sourceMappingURL=MockSnapper.js.map