'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Logger = require('./Logger');

var _Logger2 = _interopRequireDefault(_Logger);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var log = new _Logger2.default({ component: "MockWeb3" });

var MockWeb3 = function MockWeb3(props) {
  _classCallCheck(this, MockWeb3);

  this.eth = new MockEth(props);
};

exports.default = MockWeb3;

var MockContract = function () {
  function MockContract(props) {
    var _this = this;

    _classCallCheck(this, MockContract);

    this._eth = props.eth;
    ['getPastEvents'].forEach(function (fn) {
      return _this[fn] = _this[fn].bind(_this);
    });
  }

  _createClass(MockContract, [{
    key: 'getPastEvents',
    value: function () {
      var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(name, options) {
        var start, end, all, i, block;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                log.debug("Getting past events between", options.fromBlock, options.toBlock);

                start = options.fromBlock;
                end = options.toBlock;

                if (!(start > end)) {
                  _context.next = 5;
                  break;
                }

                return _context.abrupt('return', []);

              case 5:
                all = [];


                for (i = start; i <= end; ++i) {
                  block = this._eth.blocks[i];

                  if (block) {
                    block.transactions.forEach(function (t) {
                      _lodash2.default.keys(t.logEvents).forEach(function (k) {
                        var a = t.logEvents[k];
                        all = [].concat(_toConsumableArray(all), _toConsumableArray(a));
                        //log.debug("Accumulated", all.length, "txns so far...");
                      });

                      if (all.length > 1000) {
                        throw new Error("more than 1000 results");
                      }
                    });
                  }
                }
                return _context.abrupt('return', all);

              case 8:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function getPastEvents(_x, _x2) {
        return _ref.apply(this, arguments);
      }

      return getPastEvents;
    }()
  }]);

  return MockContract;
}();

var MockEth = function () {
  function MockEth() {
    var _this2 = this;

    var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, MockEth);

    this.Contract = function (abi, address) {
      var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

      return new MockContract({ abi: abi, address: address, options: options, eth: _this2 });
    };

    this.blocks = props.blocks;

    ['subscribe', 'getBlockNumber', 'getBlock', '_addBlock'].forEach(function (fn) {
      return _this2[fn] = _this2[fn].bind(_this2);
    });
  }

  _createClass(MockEth, [{
    key: 'subscribe',
    value: function subscribe(evtName) {
      throw new Error("Subscriptions not supported");
    }
  }, {
    key: 'getBlockNumber',
    value: function () {
      var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                return _context2.abrupt('return', this.block);

              case 1:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function getBlockNumber() {
        return _ref2.apply(this, arguments);
      }

      return getBlockNumber;
    }()
  }, {
    key: 'getBlock',
    value: function () {
      var _ref3 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(num) {
        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                return _context3.abrupt('return', this.blocks[num]);

              case 1:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function getBlock(_x5) {
        return _ref3.apply(this, arguments);
      }

      return getBlock;
    }()
  }, {
    key: '_addBlock',
    value: function _addBlock(b) {
      this.blocks[b.number] = b;
      this.block = b.number;
    }
  }]);

  return MockEth;
}();
//# sourceMappingURL=MockWeb3.js.map