"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
var buildEvents = exports.buildEvents = function buildEvents(count, blockNumber) {
  var events = [];
  for (var i = 0; i < count; ++i) {
    events.push({
      blockNumber: blockNumber || i,
      transactionHash: "" + (blockNumber + '_' + i),
      transactionIndex: i,
      event: "FakeEvent",
      returnValues: {
        field1: "value" + i
      }
    });
  }
  return events;
};

var buildBlocks = exports.buildBlocks = function buildBlocks(count, txnsPerBlock) {
  var blocks = [];

  var _loop = function _loop(i) {
    var events = buildEvents(txnsPerBlock, i);

    var b = {
      number: i,
      transactions: events.map(function (e) {
        var txn = {
          transactionHash: e.transactionHash,
          transactionIndex: e.transactionIndex,
          logEvents: events.reduce(function (o, evt) {
            o[evt.name] = [evt];
            return o;
          }, {})
        };
        return txn;
      })
    };
    blocks.push(b);
  };

  for (var i = 0; i < count; ++i) {
    _loop(i);
  }
  return blocks;
};
//# sourceMappingURL=test-utils.js.map